#!/usr/bin/env node
"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const yargs_parser_1 = __importDefault(require("yargs-parser"));
const glob_1 = __importDefault(require("glob"));
const babel = __importStar(require("@babel/core"));
const fs_extra_1 = __importDefault(require("fs-extra"));
const path_1 = __importDefault(require("path"));
const argv = yargs_parser_1.default(process.argv.slice(2));
const { cwd = process.cwd(), source = "src", outDir = "lib", nodeVersion = 12, } = argv;
const filesDir = path_1.default.join(cwd, source);
const toJsFile = (filePath) => {
    const { dir, name } = path_1.default.parse(filePath);
    return path_1.default.format({ dir, name, ext: ".js" });
};
const toRelative = (filePath) => path_1.default.relative(filesDir, filePath);
const files = glob_1.default
    .sync("**/*", {
    cwd: filesDir,
    nodir: true,
    absolute: true,
})
    .filter((file) => file.endsWith(".js") || file.endsWith(".ts"));
fs_extra_1.default.removeSync(outDir);
files.forEach((filePath) => {
    const { code } = babel.transformFileSync(filePath, {
        babelrc: false,
        configFile: false,
        presets: [
            [
                "@babel/preset-env",
                {
                    targets: {
                        node: nodeVersion,
                    },
                },
            ],
            "@babel/preset-typescript",
        ],
    });
    const outputPath = path_1.default.join(outDir, toJsFile(toRelative(filePath)));
    fs_extra_1.default.outputFileSync(outputPath, code, "utf-8");
});
